/*  zweic -- a compiler for Zwei
 *
 *  Stephane Micheloud & LAMP
 *
 *  $Id: Parser.java 2325 2005-11-22 11:16:18 +0100 (Tue, 22 Nov 2005) michelou $
 */

package zweic;

import java.io.InputStreamReader;
import zweic.Tree.*;


/**
 * This class implements the parser of the compiler.
 */
class Parser extends Scanner {

    public Parser(InputStreamReader in) {
        super(in);
    }

    /**
     * Reports an error that a specific token was expected but
     * a different token found.
     */
    private void error(int expected) {
        error("token of class " + tokenClass(expected));
    }

    /**
     * Reports an error that a specific token was expected but
     * a different token found.
     */
    private void error(String expected) {
        String message = "syntax error\n" +
            "expected: " + expected + "\n" +
            "found   : " + representation();
        Report.fail(start, message);
        throw new Error();
    }

    /**
     * If the current token corresponds to the token class 'expected'
     * then skip it, otherwise signal an error.
     */
    private void accept(int expected) {
        if (token == expected)
            nextToken();
        else
            error(expected);
    }

    /**
     * If the current token corresponds to the token class 'expected'
     * then skip it and return success.
     */
    private boolean check(int expected) {
        if (token == expected) {
            nextToken();
            return true;
        } else
            return false;
    }


    /**
     * Parse the input and return an abstract syntax tree.
     */
    public Program parse() {
        Program result = program();
        accept(EOF);
        return result;
    }

    /**
     * Program = { ClassDecl } Expression
     */
    private Program program() {
        // ...  complter ...
    }

    /**
     * ClassDecl = "class" ident [ "extends" ident ] "{" { FieldDecl | MethodDef } "}".
     */
    private ClassDef classDef() {
        // ...  complter ...
    }

    /**
     * Member    = FieldDecl | MethodDef
     * FieldDecl = Formal ";".
     * MethodDef = Formal "(" [ Formals ] ")" Block.
     */
    private Tree member() {
        // ...  complter ...
    }

    // ...  complter ...
}
