/*  zweic -- a compiler for Zwei
 *
 *  Stephane Micheloud & LAMP
 *
 *  $Id: Report.java 2540 2006-01-10 13:48:10 +0100 (Tue, 10 Jan 2006) michelou $
 */

package zweic;


/** This class provides functionality for printing error messages.
 */
class Report {

    /** Number of errors.
     */
    public static int errors;

    /** Prints out an error message.
     */
    public static void error(String message) {
        errors++;
        System.err.println(message);
    }

    /** Prints out an error message.
     */
    public static void error(int position, String message) {
        errors++;
        print(position, message);
    }

    /** Prints out an error message and stops the program execution.
     */
    public static void fail(String message) {
        error(message);
        System.exit(-1);
    }

    /** Prints out an error message and stops the program execution.
     */
    public static void fail(int position, String message) {
        error(position, message);
        System.exit(-1);
    }

    /** Prints out the position and the message passed as arguments.
     */
    private static void print(int position, String message) {
        System.err.println(Position.line(position) + ":" +
                           Position.column(position) + ": " +
                           message);
    }
}
